package test.com.philisense.www.controller.http.web;

import com.alibaba.fastjson.JSON;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;


import test.base.HttpUtilsForm;

import java.util.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.philisense.www.common.config.CommonConst;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.core.io.FileSystemResource;
import org.springframework.http.ResponseEntity;

public class TestProDeptControllerWithHttpClientForWeb  {




            @BeforeEach
            public void setUpTestDataWithinTransaction() {

            // set up test data within the transaction

            }

            @AfterEach
            public void tearDownWithinTransaction() {

            // execute "tear down" logic within the transaction

            }

            @Test
            @Disabled
            public void testProDeptDeleteByPrimaryKeyForWeb(){
                String id = UUID.randomUUID().toString().replaceAll("-","");
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/delete?recordid="+id;
            	String charset = HttpUtilsForm.UTF8;
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doGet(url, charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }

            @Test
            @Disabled
            public void testProDeptSelectByPrimaryKeyForWeb(){
                String id = UUID.randomUUID().toString().replaceAll("-","");
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/get?recordid="+id;
            	String charset = HttpUtilsForm.UTF8;
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doGet(url, charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }

            @Test
            @Disabled
            public void testProDeptInsertForWeb(){
            	
            	Map<String, Object> headerMap = new HashMap<String, Object>();
            	
            	headerMap.put("Content-Type", "application/json");
            	
            	
            	
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/insert";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                }               
                
            }

            @Test
            @Disabled
            public void testProDeptUpdateForWeb(){
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/update";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }

            @Test
            @Disabled
            public void testProDeptDeleteByMapForWeb(){
	        	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/deleteByMap";
	        	String charset = HttpUtilsForm.UTF8;
	        	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
	            try {
	                //括号里的是前台发送的url连接
	                String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
	                System.out.println(body);                                                       
	            } catch (Exception e) {
	                e.printStackTrace();
	            } 
                
            }

            @Test
            @Disabled
            public void testProDeptUpdateByMapForWeb(){
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/updateByMap";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }


            @Test
            @Disabled
            public void testProDeptGetOneForWeb(){
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/getOne";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }


            @Test
            @Disabled
            public void testProDeptGetAllForWeb(){
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/getAll";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }

            @Test
            @Disabled
            public void testProDeptCountForWeb(){
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/count";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }


            @Test
            @Disabled
            public void testProDeptQueryPageForWeb(){
            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/queryPage";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> params = new HashMap<String, Object>();
                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }

            @Test
            @Disabled
            public void testProDeptInsertBatchForWeb(){

                List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();


                Map<String, Object> params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式



                list.add(params);


                params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


                params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


               	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/insertBatch";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> paramsbody = new HashMap<String, Object>();
                //设置 请求参数
            	paramsbody.put("list",list);//用户Id
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            @Test
            @Disabled
            public void testProDeptDeleteBatchForWeb(){

                List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();


                Map<String, Object> params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


                params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


                params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式

                list.add(params);


            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/deleteBatch";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> paramsbody = new HashMap<String, Object>();
                //设置 请求参数
            	paramsbody.put("list",list);//用户Id
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }

            @Test
            @Disabled
            public void testProDeptUpdateBatchForWeb(){

                List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();


                Map<String, Object> params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


                params = new HashMap<String, Object>();


                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


                params = new HashMap<String, Object>();

                //设置 请求参数
                params.put("dept_id","dept_id");//部门Id
                params.put("dept_name","dept_name");//部门名称
                params.put("dept_code","dept_code");//部门code
                params.put("parentid","parentid");//父部门Id
                params.put("levelcode","levelcode");//层次码
                params.put("leaf","leaf");//是否叶子
                params.put("icon","icon");//图标
                params.put("cls","cls");//层叠样式


                list.add(params);


            	String url = HttpUtilsForm.WebconnectURL+CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/updateBatch";
            	String charset = HttpUtilsForm.UTF8;
            	Map<String, Object> paramsbody = new HashMap<String, Object>();
                //设置 请求参数
            	paramsbody.put("list",list);//用户Id
                try {
                    //括号里的是前台发送的url连接
                    String body = HttpUtilsForm.doPost(url, JSON.toJSONString(params), charset);
                    System.out.println(body);                                                       
                } catch (Exception e) {
                    e.printStackTrace();
                } 
            }


            @Test
            @Disabled
            public void testexportForProDeptForWeb() throws IOException {
                    /*
                    // 待下载的文件地址
                    String url = CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/export";
                    ResponseEntity<byte[]> rsp = template.getForEntity(url, byte[].class);
                    System.out.println("文件下载请求结果状态码：" + rsp.getStatusCode());

                    String filename = "客户用户表";
                    // 将下载下来的文件内容保存到本地
                    String targetPath = "path_xxx/"+filename+"_ProDept.xlsx";
                    Files.write(Paths.get(targetPath), Objects.requireNonNull(rsp.getBody(),
                    "未获取到下载文件"));
                    */
            }

            @Test
            @Disabled
            public void testexportTemplateForProDeptForWeb() throws IOException {
                    /*
            	    // 待下载的文件地址
                    String url = CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/exportTemplate";
                    ResponseEntity<byte[]> rsp = template.getForEntity(url, byte[].class);
                    System.out.println("文件下载请求结果状态码：" + rsp.getStatusCode());

                    // 将下载下来的文件内容保存到本地
                    String filename = "客户用户表";
                    // 将下载下来的文件内容保存到本地
                    String targetPath = "path_xxx/"+filename+"_ProDept.xlsx";
                    Files.write(Paths.get(targetPath), Objects.requireNonNull(rsp.getBody(),
                    "未获取到下载文件"));
                    */
            }

            @Test
            @Disabled
            public void testimportExcelForProDeptForWeb()  {
                /*
            	// 文件上传服务上传接口
                String url = CommonConst.WEB_REST_SERVICE_PREFICX+"prodept/importExcel";
                // 待上传的文件（存在客户端本地磁盘）
                String filename = "客户用户表";
                // 将下载下来的文件内容保存到本地
                String targetPath = "path_xxx/"+filename+"_ProDept.xlsx";
                // 封装请求参数
                FileSystemResource resource = new FileSystemResource(new File(targetPath));
                MultiValueMap<String, Object> param = new LinkedMultiValueMap<>();
                param.add("file", resource);  //服务端MultipartFile uploadFile
                //param.add("param1", "test");   //服务端如果接受额外参数，可以传递


                // 发送请求并输出结果
                System.out.println("--- 开始上传文件 ---");
                String result = template.postForObject(url, param, String.class);
                System.out.println("--- 访问地址：" + result);
                */
            }

}
